from numpy import array, exp, cos, linspace,meshgrid,identity,ones,where,inf,outer
import matplotlib
import matplotlib.pyplot as plt

def klassRK(f, y0, T, N):
    r"""
    Wendet auf eine System erster Ordnung der Form y'=f(t,y) das klassische
    Runge-Kutta-Verfahren an

    INPUT:
    f   - lambda function mit Argumenten (t,y)
    y0  - Vektor der Anfangswerte zum Zeitpunkt t0
    T   - T=[t0 tEnd] zu approximierendes Intervall
    N   - Anzahl der Iterationsschritte

    OUTPUT
    t   - Diskretisierung des Zeitintervalls
    y   - Matrix der approximierten Funktionswerte
    """
    # Anzahl der Gleichungen = Dimension der Loesung
    d = size(y0)
    # Zeitwerte und Schrittweite
    t, h = linspace(T[0], T[1], N + 1, retstep=True)

    y = zeros((d, size(t)))      # Loesungsmatrix
    y[:, 0] = y0                 # Anfangswert

    # Loesung berechnen
    for i in range(N):

        #################################################
        #                                               #
        # Implementiere die Runge-Kutta Iteration hier. #
        #                                               #
        # Hinweis: Benutze die Funtkion rkStep.         #
        # y[:,i+1] =                                    #
        #                                               #
        #################################################
        pass

    return t, y


def rkStep(f, y0, t0, h):
    # Berechnet einen RK-Schritt der Schrittweite h
    y1 = zeros_like(y0)

    ###########################################################
    #                                                         #
    # Implementiere einen einzelnen Runge-Kutta Schritt hier. #
    #                                                         #
    ###########################################################

    return y1




from numpy.linalg import det



def S(z):
    result = z
    ##########################################################
    #                                                        #
    # TODO: Implementieren Sie hier die Stabilitaetsfunktion #
    #       Schreiben Sie Herleitung und Wert auf Papier !   #
    #                                                        #
    ##########################################################
    return result

##### AUFGABE E)
xl = -5.0
xr = 3.0
yl = -4.0
yr = 4.0
xd = linspace(xl, xr, 200)
yd = linspace(yl, yr, 200)
X, Y = meshgrid(xd, yd)
Z = X + 1j * Y
Sz = array([[S(z) for z in zi] for zi in Z])

plt.figure(figsize=(6, 6))
plt.contourf(X, Y, where(abs(Sz) <= 1.0, 1.0, -inf), levels=linspace(0, 2, 51))
plt.contour(X, Y, abs(Sz), levels=[1.0], colors='k', linewidths=[2])
plt.xlim(-5, 3)
plt.grid(True)
plt.ylim(-4, 4)
plt.xlabel(r'$\Re z$')
plt.ylabel(r'$\Im z$')
plt.show()
plt.savefig('RK_StabilityDomain.png')
